require 'rails_helper'

RSpec.describe TbCommerce::Option, type: :model do

  describe '#label' do
    it 'should return the option set name' do
      set = FactoryGirl.create(:tb_commerce_option_set)
      option = FactoryGirl.create(:tb_commerce_option, :option_set => set)
      expect(option.label).to eq(set.name)
    end
  end

  describe '#set_sort_order' do
    it 'should set the sort_order to n+1' do
      set = FactoryGirl.create(:tb_commerce_option_set)
      option_a = FactoryGirl.create(:tb_commerce_option, :option_set => set)
      option_b = FactoryGirl.create(:tb_commerce_option, :option_set => set)
      expect(option_b.sort_order).to eq(option_a.sort_order+1)
    end
  end

end
